﻿Imports System.ComponentModel

''' <summary>
''' 独自描画のトラックバー。System.Windows.Forms.TrackBarを継承
''' </summary>
''' <remarks></remarks>
Public Class ColorTrackbar
    ' プロパティ用変数
    Private prop_imgBack As Image
    Private prop_imgTrack As Image

    Public Sub New()
        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
    End Sub

    Public Sub Init()
        If TrackImage IsNot Nothing Then
            Me.SetStyle(ControlStyles.UserPaint, True)
            Me.SetStyle(ControlStyles.AllPaintingInWmPaint, True)
        End If
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        'MyBase.OnPaint(e) ' 全て独自描画とする
        If Not e.ClipRectangle.Height = Me.Height Then ' 全体で更新するようにする
            Invalidate()
            Return
        End If

        If Me.DesignMode Then
            e.Graphics.DrawRectangle(Pens.Black, 0, 0, Me.Width - 1, Me.Height - 1)
        End If

        If BackImage IsNot Nothing Then ' 背景描画
            e.Graphics.DrawImage(BackImage, 0, 0)
        End If

        If TrackImage IsNot Nothing Then ' トラックボタン描画
            Dim rcTrack As Rectangle
            If Me.Orientation = Windows.Forms.Orientation.Horizontal Then
            Else ' 縦型のトラックのみ実装
                rcTrack = New Rectangle((Me.Width - TrackImage.Width) / 2, 9, TrackImage.Width, TrackImage.Height)
                rcTrack.Y = 9 + (((Me.Maximum - Me.Minimum - Me.Value) * (Me.Height - 18 - TrackImage.Height)) / (Me.Maximum - Me.Minimum))
                e.Graphics.DrawImage(TrackImage, rcTrack)
            End If
        Else ' TrackImageがある場合のみ実装
        End If
    End Sub

    ''' <summary>
    ''' 背景イメージ
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("ColorTrackbar")> _
    <Description("背景イメージ")> _
    Public Property BackImage() As Image
        Get
            Return prop_imgBack
        End Get
        Set(ByVal value As Image)
            prop_imgBack = value
        End Set
    End Property

    ''' <summary>
    ''' トラックボタンイメージ
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("ColorTrackbar")> _
    <Description("トラックボタンイメージ")> _
    Public Property TrackImage() As Image
        Get
            Return prop_imgTrack
        End Get
        Set(ByVal value As Image)
            prop_imgTrack = value
        End Set
    End Property

End Class
