Imports System.IO
Imports System.ComponentModel

Public Structure FilesInfo
    Public nFileNumTotal As Integer
    Public lFileSizeTotal As Long
    Public nFileNumImages As Integer
    Public lFileSizeImages As Long
End Structure

''' <summary>
''' 摜TlC\NXBPhotoListUIƂň̖
''' </summary>
''' <remarks></remarks>
Public Class PhotoListCtl
#Region "o[ϐENXECxg"
    Private photoListUI1 As PhotoListUI
    Private m_filesinfo As FilesInfo ' t@C

    Private Const CtrlMask As Integer = 8 ' L[{[h擾p
    Private Const ShiftMask As Integer = 4

    Public Event DoubleClickEvent As MouseEventHandler ' s̒ʒmƂẴCxg
#End Region

#Region "VXe֐"
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer. 
        InitializeComponent()

        photoListUI1 = New PhotoListUI() ' PhotoListUI̓fUCił͂Ȃō쐬
        photoListUI1.Name = "photoListUI"
        photoListUI1.Location = New System.Drawing.Point(0, 0)
        photoListUI1.Size = Me.ClientSize
        AddHandler photoListUI1.DoubleClickEvent, AddressOf PhotoListUI1_DoubleClickEvent
        AddHandler photoListUI1.UpdateEvent, AddressOf PhotoListUI1_UpdateEvent
        AddHandler photoListUI1.SelItemChangeEvent, AddressOf PhotoListUI1_SelItemChangeEvent
        Me.Controls.Add(Me.photoListUI1)

        Me.SetStyle(ControlStyles.SupportsTransparentBackColor, True)
    End Sub

    ''' <summary>
    ''' }EXCxgB
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PhotoListCtl_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        If IsDBNull(photoListUI1) Then
            Return
        End If
        If e.Button = Windows.Forms.MouseButtons.Right Then
            photoListUI1.ClearSelect()
        ElseIf e.Button = Windows.Forms.MouseButtons.Left Then
            If ModifierKeys = Keys.None Then ' Alt,Shift,CtrlĂȂ΃NA
                photoListUI1.ClearSelect()
            End If
        End If
    End Sub

    ''' <summary>
    ''' XN[CxgBphotoListUIANeBuRg[Ƃ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PhotoListCtl_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles MyBase.Scroll
        If Not photoListUI1.Focused Then
            ActiveControl = photoListUI1
        End If
    End Sub

    ''' <summary>
    ''' hbOhbvBtH_̃t@C̓hbvȂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PhotoListCtl_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragDrop
        Dim filePathName As String() = e.Data.GetData(DataFormats.FileDrop, False)
        For Each strFile As String In filePathName
            If strFile.CompareTo(photoListUI1.BaseFolder) = 0 Then

            ElseIf Not Path.GetDirectoryName(strFile).CompareTo(photoListUI1.BaseFolder) = 0 Then
                CopyFolders(strFile, photoListUI1.BaseFolder, False)
            End If
        Next
        SetImages(photoListUI1.BaseFolder)
    End Sub

    ''' <summary>
    ''' hbOhbvBtH_̃t@C̓hbvȂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PhotoListCtl_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            Dim filePathName As String() = e.Data.GetData(DataFormats.FileDrop, False)

            Dim bCurFolder As Boolean = True
            For Each strFile As String In filePathName
                If strFile.CompareTo(photoListUI1.BaseFolder) = 0 Then

                ElseIf Not Path.GetDirectoryName(strFile).CompareTo(photoListUI1.BaseFolder) = 0 Then
                    bCurFolder = False
                End If
            Next

            If bCurFolder Then
                e.Effect = DragDropEffects.None
                Return
            End If


            If ((e.KeyState And CtrlMask) = CtrlMask) And ((e.AllowedEffect And DragDropEffects.Copy) = DragDropEffects.Copy) Then
                e.Effect = DragDropEffects.Copy
            ElseIf ((e.KeyState And ShiftMask) = ShiftMask) And ((e.AllowedEffect And DragDropEffects.Move) = DragDropEffects.Copy) Then
                e.Effect = DragDropEffects.Move
            Else
                e.Effect = DragDropEffects.Copy
            End If
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub
#End Region

#Region "[U[֐"

    ''' <summary>
    ''' IACeύXCxg󂯎XN[mF
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub PhotoListUI1_SelItemChangeEvent(ByVal index As Integer, ByVal rc As Rectangle)
        Dim x, y As Integer
        Dim curX, curY As Integer
        Dim bScroll As Boolean = False
        curX = Math.Abs(Me.AutoScrollPosition.X)
        curY = Math.Abs(Me.AutoScrollPosition.Y)
        x = rc.Left
        y = rc.Top
        If x < curX Then
            bScroll = True
        End If
        If y < curY Then
            bScroll = True
        End If
        If x + rc.Width > curX + Me.ClientSize.Width Then
            bScroll = True
        End If
        If y + rc.Height > curY + Me.ClientSize.Height Then
            bScroll = True
        End If

        If bScroll Then
            Me.AutoScrollPosition = New Point(x, y)
        End If
    End Sub

    ''' <summary>
    ''' _uNbNCxg󂯎AXɐeɒʒm
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PhotoListUI1_DoubleClickEvent(ByVal sender As Object, ByVal e As MouseEventArgs)
        RaiseEvent DoubleClickEvent(sender, e)
    End Sub

    ''' <summary>
    ''' XVCxg󂯎AXVs
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub PhotoListUI1_UpdateEvent()
        SetImages(photoListUI1.BaseFolder)
    End Sub

    Private Function PathEndAddSeparator(ByVal strPath As String) As String
        Dim strPathSp As String = strPath
        If Directory.Exists(strPath) = True Then
            If Not strPath(strPath.Length - 1) = Path.DirectorySeparatorChar Then
                strPathSp = strPath + Path.DirectorySeparatorChar
            End If
        End If
        Return strPathSp
    End Function

    ''' <summary>
    ''' tH_𒆐gƃRs[
    ''' </summary>
    ''' <param name="sSource">Rs[̃t@CEtH_</param>
    ''' <param name="sDest">Rs[̃tH_</param>
    ''' <param name="bForce">㏑mFoȂȂTrue</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function CopyFolders(ByVal sSource As String, ByVal sDest As String, ByVal bForce As Boolean) As Boolean
        Dim bRet As Boolean = True
        Dim sFolders As String()
        Dim sFiles As String()
        Dim sFolder As String
        Dim sFile As String
        Dim sNewFolder As String
        Dim sNewFile As String

        Try
            If sDest.Length >= sSource.Length Then
                If sDest.Substring(0, sSource.Length).CompareTo(sSource) = 0 Then
                    bRet = False
                    MessageBox.Show("Rs[ł܂BRs[ɃRs[̃tH_܂܂Ă܂B", My.Application.Info.Title, MessageBoxButtons.OK)
                    Exit Try
                End If
            End If

            If Not Directory.Exists(sDest) Then
                Directory.CreateDirectory(sDest)
            End If
            If (File.GetAttributes(sSource) And FileAttributes.Directory) = FileAttributes.Directory Then
                sNewFolder = PathEndAddSeparator(sDest) + Path.GetFileName(sSource)
                If Not Directory.Exists(sNewFolder) Then
                    Directory.CreateDirectory(sNewFolder)
                End If

                sFiles = Directory.GetFiles(sSource)
                For Each sFile In sFiles
                    sNewFile = PathEndAddSeparator(sNewFolder) + Path.GetFileName(sFile)
                    Try
                        If Not bForce Then
                            If File.Exists(sNewFile) Then
                                If MessageBox.Show("t@C݂܂B㏑܂H", My.Application.Info.Title, MessageBoxButtons.YesNo) = DialogResult.No Then
                                    Continue For
                                End If
                            End If
                        End If
                        File.Copy(sFile, sNewFile, True)
                    Catch ex As Exception
                        bRet = False
                        MessageBox.Show(sFile + "̃Rs[ŃG[܂B", My.Application.Info.Title, MessageBoxButtons.OK)
                    End Try
                Next

                sFolders = Directory.GetDirectories(sSource)
                For Each sFolder In sFolders
                    If Not CopyFolders(sFolder, sNewFolder, bForce) Then
                        bRet = False
                        Exit For
                    End If
                Next
            Else ' ŏt@Cꍇ̏
                sNewFile = PathEndAddSeparator(sDest) + Path.GetFileName(sSource)
                If Not bForce Then
                    If File.Exists(sNewFile) Then
                        If MessageBox.Show("t@C݂܂B㏑܂H", My.Application.Info.Title, MessageBoxButtons.YesNo) = DialogResult.No Then
                            Return bRet
                        End If
                    End If
                End If
                File.Copy(sSource, sNewFile, True)
            End If
        Catch ex As Exception
            bRet = False
            MessageBox.Show(sSource + "̃Rs[ŃG[܂B", My.Application.Info.Title, MessageBoxButtons.OK)
        End Try

        Return bRet
    End Function

    ''' <summary>
    ''' Jݒ肷BPhotoListCtl̃TCYɂvZ
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub AutoColumn()
        Dim col As Integer

        If IsDBNull(photoListUI1) Then
            Return
        End If

        col = Int(Me.ClientSize.Width / (ThumbSize.Width + HorzSpace))
        If col < 1 Then
            col = 1
        End If
        If col > photoListUI1.MaxCol Then
            col = photoListUI1.MaxCol
        End If
        Columns = col
    End Sub

    ''' <summary>
    ''' sBRg[gp鑤PĂяoKv
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub InitView()
        If Me.DesignMode = False Then
            photoListUI1.Init()
        End If
    End Sub

    ''' <summary>
    ''' tH_̃C[Wt@CXgɐݒ肷
    ''' </summary>
    ''' <param name="strFolder"></param>
    ''' <remarks></remarks>
    Public Sub SetImages(ByVal strFolder As String)
        Dim strImageExts As String = ".jpg;.bmp;.gif;.tiff;.png;" ' ̊gq̃t@CΏۂƂ
        Dim fileinfo As FileInfo()
        Dim oFile As FileInfo
        Dim myImageFolder As String
        Dim imgd As ImageData

        If Me.DesignMode = False Then
            m_filesinfo.lFileSizeTotal = 0
            m_filesinfo.nFileNumTotal = 0
            m_filesinfo.lFileSizeImages = 0
            m_filesinfo.nFileNumImages = 0
            photoListUI1.ClearImages()
            myImageFolder = strFolder
            photoListUI1.BaseFolder = strFolder
            Dim oFolder As DirectoryInfo = Nothing
            Try
                oFolder = New IO.DirectoryInfo(myImageFolder)
                fileinfo = oFolder.GetFiles("*.*", IO.SearchOption.TopDirectoryOnly)
                For Each oFile In fileinfo
                    m_filesinfo.lFileSizeTotal += oFile.Length
                    m_filesinfo.nFileNumTotal += 1
                    If (oFile.Extension.Length > 1) And (strImageExts.IndexOf(oFile.Extension, StringComparison.CurrentCultureIgnoreCase) >= 0) Then
                        m_filesinfo.lFileSizeImages += oFile.Length
                        m_filesinfo.nFileNumImages += 1

                        imgd = New ImageData
                        imgd.bLoaded = False
                        imgd.strName = oFile.FullName
                        imgd.strFile = oFile.Name
                        photoListUI1.AddImageData(imgd)
                    End If
                Next
            Catch ex As Exception
                If oFolder Is Nothing Then

                End If

            End Try
            UpdateImageList()
            Me.AutoScrollPosition = New Point(0, 0)
        End If
    End Sub

    ' Rg[̃TCYXgɍ킹
    Public Sub UpdateImageList()
        If Me.DesignMode = False Then
            photoListUI1.UpdateImageList()
        End If
    End Sub

    ' SẴC[Wēǂݍ݂
    Public Sub ReloadAll()
        If Me.DesignMode = False Then
            photoListUI1.ReloadAll()
        End If
    End Sub

    ' IĂC[Wēǂݍ݂
    Public Sub ReloadSelected()
        If Me.DesignMode = False Then
            photoListUI1.ReloadSelected()
        End If
    End Sub

    ' IĂC[W̃t@C̃XgNbv{[hɃRs[
    Public Function ClipCopyFiles() As Boolean
        Dim bRet As Boolean = False
        If Me.DesignMode = False Then
            bRet = photoListUI1.ClipCopyFiles
        End If
        Return bRet
    End Function

    ' IĂt@C폜
    Public Function DeleteFiles() As Boolean
        Dim bRet As Boolean = False
        If Me.DesignMode = False Then
            bRet = photoListUI1.DeleteFiles(False)
            SetImages(photoListUI1.BaseFolder)
        End If
        Return bRet
    End Function

    ' Nbv{[h̃t@CXgtH_ɃRs[
    Public Function PasteFolder() As Boolean
        Dim bRet As Boolean = False
        If Me.DesignMode = False Then
            bRet = photoListUI1.PasteFolder()
            SetImages(photoListUI1.BaseFolder)
        End If
        Return bRet
    End Function
#End Region

#Region "vpeB"
    <Category("PhotoListCtl")> _
    <Description("t@C")> _
    Public ReadOnly Property FilesInfo()
        Get
            Return m_filesinfo
        End Get
    End Property

    ''' <summary>
    ''' Xg̉Xy[X
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("Xg̉Xy[X")> _
    Public Property HorzSpace() As Integer
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.HorzSpace
            Else
                Return 0
            End If
        End Get
        Set(ByVal value As Integer)
            If Not IsDBNull(photoListUI1) Then
                photoListUI1.HorzSpace = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' Xg̏cXy[X
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("Xg̏cXy[X")> _
    Public Property VertSpace() As Integer
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.VertSpace
            Else
                Return 0
            End If
        End Get
        Set(ByVal value As Integer)
            If Not IsDBNull(photoListUI1) Then
                photoListUI1.VertSpace = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' J
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("J")> _
    Public Property Columns() As Integer
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.Columns
            Else
                Return 3
            End If
        End Get
        Set(ByVal value As Integer)
            If Not IsDBNull(photoListUI1) Then
                photoListUI1.Columns = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' t@C\邩
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("t@C\邩")> _
    Public Property ShowFileName() As Boolean
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.ShowFileName
            End If
            Return False
        End Get
        Set(ByVal value As Boolean)
            If Not IsDBNull(photoListUI1) Then
                photoListUI1.ShowFileName = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' ^Cg\邩
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("^Cg\邩")> _
    Public Property ShowTitle() As Boolean
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.ShowTitle
            End If
            Return False
        End Get
        Set(ByVal value As Boolean)
            If Not IsDBNull(photoListUI1) Then
                photoListUI1.ShowTitle = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' Rg\邩
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("Rg\邩")> _
    Public Property ShowComment() As Boolean
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.ShowComment
            End If
            Return False
        End Get
        Set(ByVal value As Boolean)
            If Not IsDBNull(photoListUI1) Then
                photoListUI1.ShowComment = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' TlC̃TCY
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("TlC̃TCY")> _
    Public Property ThumbSize() As Size
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.ThumbSize
            End If
            Return Nothing
        End Get
        Set(ByVal value As Size)
            If Not IsDBNull(photoListUI1) Then
                photoListUI1.ThumbSize = value
            End If
        End Set
    End Property

    ''' <summary>
    ''' IĂC[W̃Xg
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("IĂC[W̃Xg")> _
    Public ReadOnly Property SelectedImages() As ImageDataList
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.SelectedImages
            End If

            Return Nothing
        End Get
    End Property

    ''' <summary>
    ''' SC[W̃Xg
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("PhotoListCtl")> _
    <Description("SC[W̃Xg")> _
    Public ReadOnly Property AllImages() As ImageDataList
        Get
            If Not IsDBNull(photoListUI1) Then
                Return photoListUI1.AllImages
            End If

            Return Nothing
        End Get
    End Property
#End Region

End Class



